(define (remove-element elem list)
	(cond ((eq? list '()) '())
				((not (list? list)) list)
				((eq? (car list) elem) (remove-element elem (cdr list)))
				(else (cons (remove-element elem (car list)) (remove-element elem (cdr list))))
	)
)

(letrec
		(
			(gerade? (lambda (n) (if (zero? n) #t (ungerade? (- n 1)))))
			(ungerade? (lambda (n) (if (zero? n) #f (gerade? (- n 1)))))
		)
  (gerade? 23)
)

(let ((a '(du)) (b '(ich)) (c '(er))) (define (oder a b) (cond ((null? a) b) (else (oder (cdr a) (append b '(oder) (list (car a))))))) (oder b c))

(let ((hi1 'hihi))
	(define (hi2 hi3)
		(lambda (hi4) (cons hi4 hi4)))
	((hi2 hi2) 'hi)) 


(define (combine l1 l2) (let hlp ((x l1) (y (reverse l2))) (cond ((or (null? x) (null? (cdr x)) (null? y)) '()) (else (cons (cons (car x) (car y)) (hlp (cddr x) (cdr y)))))))
(combine '(diese aufgabe ist nicht so einfach) '(schwer nicht klausur) ) 

(define (berechne a b c) (b a c))

(define (the-empty-tree) (list '() '() '()))

(define (make-node elem) (list elem '() '()))

(define (element-einfuegen elem baum)
	(cond ((eq? '() (car baum)) (set-car! baum elem))
				((< elem (car baum))
				 (if (eq? '() (cadr baum))
				 (set-car! (cdr baum) (make-node elem))
				 (element-einfuegen elem (cadr baum))))
				((> elem (car baum))
				 (if (eq? '() (caddr baum))
				 (set-car! (cddr baum) (make-node elem))
				 (element-einfuegen elem (caddr baum))))
	)
)

;(define baum (the-empty-tree))
;(element-einfuegen baum 7)
;(element-einfuegen baum 8)
;(element-einfuegen baum 5)
;(element-einfuegen baum 6)
;baum

(define (square x) (* x x))

(define (fastexpmod basis exponent mod)
	(remainder 
					(cond ((even? exponent) (square (fastexpmod basis (/ exponent 2) mod)))
								((= 1 exponent) basis)
								(else (* (square (fastexpmod basis (/ (- exponent 1) 2) mod)) basis))
					)
					mod)
)

;(define (fermat n)
;	(let ((a (random-integer n)))
;		(= a (fastexpmod a n n))))

(define (fermat n)
	(define (fermat-helper a)
		(= a (fastexpmod a n n)))
	(fermat-helper (random-integer n)))

(define (iter max func param)
	(if (= max 0) #t
		(and (func param) (iter (- max 1) func param)
		)
	)
)

(define (probable-prime? p)
	(iter (ceiling (/ (log p) (log 2))) fermat p)
)


(define (make-iterator)
	(let ((p 3))
		(define (next-element2)
			(cond ((probable-prime? p) (set! p (+ p 2)) (- p 2))
						(else (set! p (+ p 2)) (next-element2))
			)
		)
			
		(define (next-element)
			(set! next-element next-element2)
			2
		)

		(define (dispatcher m)
			(cond ((eq? m 'next-element) next-element)
						(else (error "unknown function"))
			)
		)
		dispatcher
	)
)



;(define it (make-iterator))
;((it 'next-element) param param2)

(define (make-particle x y vx vy v)
	(let ((age 0))

		(define (print-position)
			(display x) (display " ") (display y) (newline)
		)
		(define (print)
			(display x)
			(display " ")
			(display y)
			(display " ")
			(display vx)
			(display " ")
			(display vy)
			(display " ")
			(display v)
			(newline)
		)

		(define (next-element)
			(set! age (+ age 1))
			(set! x (+ x (* v vx)))
			(set! y (+ y (* v vy)))
		)
		
		(define (dispatch m)
			(cond ((eq? m 'print-position) print-position)
						((eq? m 'print) print)
						((eq? m 'next-element) next-element)
						(else (error "fehler!"))
			)
		)
		dispatch
	)
)

(define (make-standard-particle vx vy v)
	(make-particle 0 0 vx vy v)
)

(define (make-standard-random-particle)
	(make-standard-particle
		(- (random-integer 11) 5)
		(- (random-integer 11) 5)
		(- (random-integer 11) 5)
	)
)

(define (filter pred list)
	(cond ((eq? '() list) list)
				((not (pred (car list)))   (filter pred (cdr list)))
				(else (cons (car list) (filter pred (cdr list))))
	)
)


(define (make-particle-list n)
	(define (create-list n)
		(if (= n 0) '()
			(cons (make-standard-random-particle) (create-list (- n 1)))
		)
	)
	(let ((liste (create-list n)))

		(define (print-particles)
			(define (print-help liste)
				(cond ((not (eq? liste '()))
								(((car liste) 'print-position))
								(print-help (cdr liste))
							)
				)
			)
			(print-help liste)
		)

		(define (simulate-particles n)
			(define (sim-helper liste)
				(cond ((not (eq? liste '()))
					(((car liste) 'next-element))
					(sim-helper (cdr liste))
				))
			)
				
			(if (> n 0)
				(begin
					(sim-helper liste)
					(simulate-particles (- n 1))
				)
			)
		)
		
		(define (dispatch m)
			(cond ((eq? m 'print-particles) print-particles)
						((eq? m 'simulate-particles) simulate-particles)
						(else (error "fehler!"))
			)
		)
		dispatch
	)
)


;(define (make-point x y)
;	(define (dispatcher m)
;		(cond ((eq? m 'x) x)
;					((eq? m 'y) y)
;					(else (error "fehler!"))
;		)
;	)
;	dispatcher
;)

(define (make-point x y) (cons x y))
(define (x-coord p) (car p))
(define (y-coord p) (cdr p))

(define make-point cons)
(define x-coord car)
(define y-coord cdr)


(define (make-line start end) (cons start end))
(define startpoint car)
(define endpoint cdr)

;(define (make-line start end)
;	(define (dispatcher m)
;		(cond ((eq? m 'start) start)
;					((eq? m 'end) end)
;					(else (error "Fehler!"))
;		)
;	)
;	dispatcher
;)

(define (direction l)
	(make-point (- (x-coord (startpoint l)) (x-coord (endpoint l)))
							(- (y-coord (startpoint l)) (y-coord (endpoint l)))
	)
)


(define (mid-point l)
	(make-point (/ (+ (x-coord (startpoint l)) (x-coord (endpoint l))) 2)
							(/ (+ (y-coord (startpoint l)) (y-coord (endpoint l))) 2)
	)
)
