(define (make-particle x y vx vy v)
	(let ((age 0))

		(define (print-position)
			(display x) (display " ") (display y) (newline)
		)
		(define (print)
			(display x)
			(display " ")
			(display y)
			(display " ")
			(display vx)
			(display " ")
			(display vy)
			(display " ")
			(display v)
			(newline)
		)

		(define (next-element)
			(set! age (+ age 1))
			(set! x (+ x (* v vx)))
			(set! y (+ y (* v vy)))
		)
		
		(define (dispatch m)
			(cond ((eq? m 'print-position) print-position)
						((eq? m 'print) print)
						((eq? m 'next-element) next-element)
						(else (error "fehler!"))
			)
		)
		dispatch
	)
)

(define (make-standard-particle vx vy v)
	(make-particle 0 0 vx vy v)
)

(define (make-standard-random-particle)
	(make-standard-particle
		(- (random-integer 11) 5)
		(- (random-integer 11) 5)
		(- (random-integer 11) 5)
	)
)



(define (make-particle-list n)
	(define (create-list n)
		(if (= n 0) '()
			(cons (make-standard-random-particle) (create-list (- n 1)))
		)
	)
	(let ((liste (create-list n)))

		(define (print-particles)
			(define (print-help liste)
				(cond ((not (eq? liste '()))
								(((car liste) 'print-position))
								(print-help (cdr liste))
							)
				)
			)
			(print-help liste)
		)

		(define (simulate-particles n)
			(define (sim-helper liste)
				(cond ((not (eq? liste '()))
					(((car liste) 'next-element))
					(sim-helper (cdr liste))
				))
			)
				
			(if (> n 0)
				(begin
					(sim-helper liste)
					(simulate-particles (- n 1))
				)
			)
		)
		
		(define (dispatch m)
			(cond ((eq? m 'print-particles) print-particles)
						((eq? m 'simulate-particles) simulate-particles)
						(else (error "fehler!"))
			)
		)
		dispatch
	)
)

(define a (make-particle-list 20))
((a 'simulate-particles) 5)
((a 'print-particles))
