hilfe :- write('Hilfesystem zum Expertensystem'), nl,
	write('Mit kneipenVorschlag(Kneipe, Geschmack, Budget) bekommen Sie einen Kneipenvorschlag').


kneipe(kanapee).
kneipe(pleitegeier).
kneipe(tio).
getraenk(cola).
getraenk(bier).


%--------------------------------------------------------------------
% kneipenVorschlag/3

kneipenVorschlag(Kneipe, Geschmack, Budget) :-
  entsprichtGeschmack(Kneipe, Geschmack),
  entsprichtBudget(Kneipe, Budget).

%--------------------------------------------------------------------
% tip/2
% tip(Kneipe, Tip)
% z.B. 

tip(cycles, sonntagsFruehstueckAmNachmittag).
tip(tio, pizzaHappyHour).
tip(tio, sonntagsBrunch).

%--------------------------------------------------------------------
% entsprichtGeschmack/2
% z.B.

entsprichtGeschmack(kanapee, informatikStudent).
entsprichtGeschmack(tio, italienisch).

%--------------------------------------------------------------------
% kostet/3
% kostet(Kneipe, SpeiseOderGetraenk, Preis).
% z.B. 

kostet(kanapee, bier, 2.30).  % stimmt das? *g*

%--------------------------------------------------------------------
% wir machen budget-Vorstellungen an diversen Preisen fest
% entsprichtBudget/2
% entsprichtBudget(Kneipe, Budget)

% wer viel Kohle hat kann ueberall hin
entsprichtBudget(_, dickerGeldbeutel). 

entsprichtBudget(Kneipe, Budget) :-
  bietetAn(Kneipe, SpeiseOderGetraenk),
  kostet(Kneipe, SpeiseOderGetraenk, Preis),
  entsprichtBudget(SpeiseOderGetraenk, Budget, Preis).

%--------------------------------------------------------------------
% entsprichtBudget/3
% entsprichtBudget(SpeiseOderGetraenk, Budget, Preis)

entsprichtBudget(bier, kleinerGeldbeutel, Preis) :-
  Preis < 2.50.

entsprichtBudget(bier, groessererGeldbeutel, Preis) :-
  Preis < 3.50.

%--------------------------------------------------------------------
% bietetAn/2
% bietetAn(Kneipe, SpeiseOderGetraenk).
% z.B.

bietetAn(kanapee, bier).
bietetAn(kanapee, pizza).
bietetAn(tio, pizza).
bietetAn(pleitegeier, pizza).
bietetAn(pleitegeier, bier).
bietetAn(havannaBar, cocktails).

%--------------------------------------------------------------------
% entfernung/3
% entfernung( Start, Ziel, Kilometer )

entfernung( tio, kanapee, 2.40 ).
entfernung( pleitegeier, kanapee, 0.38 ).
entfernung( havannaBar, kanapee, 0.35 ).
entfernung( pleitegeier, havannaBar, 0.34 ).
entfernung( pleitegeier, tio, 1.80 ).


%--------------------------------------------------------------------
% ...
% happyHour(Kneipe, [Tage], Anfangszeit, Endzeit, Angebot, Preis)

happyHour(tio, [montag, dienstag, mittwoch, donnerstag, freitag], 15, 17, pizza, unbekannt).

tour(Start, Ziel, Dist, List) :- tour_helper(Start, Ziel, Dist, [Start], List).

tour_helper(Start, Start, Dist, _, [Start]) :- Dist >= 0.

tour_helper(Start, Ziel, Dist, Visited, [Start | List]) :- Dist > 0,
			( entfernung(Start, X, Zwischendist);
			  entfernung(X, Start, Zwischendist) ),
			\+member(X, Visited),
			Zwischendist2 is Dist-Zwischendist, tour_helper(X, Ziel, Zwischendist2, [X | Visited], List).
